Summary:		PowerDNS is a Versatile Database Driven Nameserver
Name:			pdns-server
Version:		2.9.21
Release:		2%{dist}
Epoch:			8
License:		GPL
Group:			System/Servers
URL:			http://www.powerdns.com/
Source0:		pdns-%{version}.tar.gz
Patch0:			pdns-2.9.21-init.patch
Patch1:			pdns-2.9.21-ldap.patch 
Source1:		rtfm.powerdns.com.tar.bz2

BuildRequires:  	autoconf automake
BuildRequires:		bison
BuildRequires:		flex
BuildRequires:		gdbm-devel
BuildRequires:		libstdc++-devel
BuildRequires:		zlib-devel

Provides:		nameserver pdns-server
Conflicts:		bind
Obsoletes:		powerdns

BuildRoot:     		%{_tmppath}/%{name}-%{version}-root
BuildRequires:		openssl-devel

%description
PowerDNS is a versatile nameserver which supports a large number
of different backends ranging from simple zonefiles to relational
databases and load balancing/failover algorithms.

This RPM comes with support for MySQL, PostgreSQL, Bind zonefiles and the 'pipe
backend' availible as external packages.

%package		backend-pipe
Summary:		Pipe/coprocess backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
Obsoletes:              powerdns-backend-pipe

%description		backend-pipe
This package contains the pipe backend for the PowerDNS nameserver. This
allows PowerDNS to retrieve domain info from a process that accepts
questions on stdin and returns answers on stdout. 

%package		backend-mysql
Summary:		MySQL backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
Requires:		mysql
BuildRequires:		mysql-devel
Obsoletes:              powerdns-backend-mysql

%description		backend-mysql
This package contains the MySQL backend for the PowerDNS nameserver.

%package		backend-postgresql
Summary:		postgesql backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
Requires:		postgresql
BuildRequires:		postgresql-devel
Obsoletes:              powerdns-backend-postgresql

%description		backend-postgresql
This package contains the postgesql backend for the PowerDNS nameserver.

%package		backend-ldap
Summary:		LDAP backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
Requires:		openldap
BuildRequires:		openldap-devel
Obsoletes:              powerdns-backend-ldap

%description		backend-ldap
This package contains the LDAP backend for the PowerDNS nameserver.

%package		backend-opendbx
Summary:		OpenDBX backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
Requires:		opendbx >= 1.2.1
BuildRequires:		opendbx-devel >= 1.2.1
Obsoletes:              powerdns-backend-opendbx

%description		backend-opendbx
This package contains the OpenDBX backend for the PowerDNS nameserver.

%package		devel
Summary:		Development headers and libraries for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
Requires:		%{name}-backend-pipe = %{version}
Requires:		%{name}-backend-mysql = %{version}
Requires:		%{name}-backend-pgsql = %{version}
Requires:		%{name}-backend-sqlite = %{version}
Requires:		%{name}-backend-ldap = %{version}
Requires:		%{name}-backend-opendbx = %{version}

%description		devel
Development headers and libraries for %{name}

%prep
%setup -q -n pdns-%{version} -a1
%patch0 -p0 -b .init
%patch1 -p3 -b .ldap

%build
%configure \
    --sysconfdir=%{_sysconfdir}/powerdns \
    --libdir=%{_libdir} \
    --with-socketdir=/var/run/pdns-server \
    --with-modules="" \
    --with-dynmodules="pipe gmysql gpgsql ldap opendbx" \
    --with-pgsql-includes=/usr/include 
%{__make}

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

#install -d $RPM_BUILD_ROOT%{_initrddir}/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/powerdns/
install -d $RPM_BUILD_ROOT%{_localstatedir}/run/pdns-server

%{__make} DESTDIR=$RPM_BUILD_ROOT install

# fix the config
mv $RPM_BUILD_ROOT%{_sysconfdir}/powerdns/pdns.conf-dist $RPM_BUILD_ROOT%{_sysconfdir}/powerdns/pdns.conf

cat >> $RPM_BUILD_ROOT%{_sysconfdir}/powerdns/pdns.conf << EOF
module-dir=%{_libdir}/powerdns
socket-dir=/var/run/pdns-server
setuid=powerdns
setgid=powerdns
launch=bind
#recursor=127.0.0.1:5300
EOF

chmod 600 $RPM_BUILD_ROOT%{_sysconfdir}/powerdns/pdns.conf

# install sysv scripts
install -d $RPM_BUILD_ROOT%{_initrddir}
install -m755 pdns/pdns $RPM_BUILD_ROOT%{_initrddir}/pdns-server

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre
if [ -z "`/usr/bin/id -g powerdns 2>/dev/null`" ]; then
    /usr/sbin/groupadd -g 25 -r -f powerdns 2>&1 || :
fi
if [ -z "`/usr/bin/id -u powerdns 2>/dev/null`" ]; then
    /usr/sbin/useradd -u 25 -r -M -d /tmp  -s /sbin/nologin -c "PowerDNS" -g powerdns powerdns 2>&1 || :
fi

%post
/sbin/ldconfig
/sbin/chkconfig --add pdns-server

%preun
if [ $1 -eq 0 ]; then
    /sbin/service pdns-server stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del pdns-server

    if [ -d /var/run/pdns-server ]; then
	rm -rf /var/run/pdns-server/*
    fi
fi

%postun
/sbin/ldconfig
if [ $1 -eq 0 ]; then
    rm -rf %{_localstatedir}/run/pdns-server/
    /usr/sbin/userdel powerdns 2>/dev/null || :
    /usr/sbin/groupdel powerdns 2>/dev/null || :
else
    /sbin/service pdns-server condrestart >/dev/null 2>&1
fi

%files
%defattr(-,root,root)
%doc ChangeLog HACKING INSTALL README TODO rtfm.powerdns.com
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/powerdns/pdns.conf
%config(noreplace) %attr(0755,root,root) %{_initrddir}/pdns-server
%dir %{_sysconfdir}/powerdns
%dir %attr(0755,powerdns,powerdns) /var/run/pdns-server
%{_bindir}/pdns_control
%{_bindir}/zone2sql
%{_bindir}/zone2ldap
%{_sbindir}/pdns_server
%{_mandir}/man8/pdns_control.8*
%{_mandir}/man8/pdns_server.8*
%{_mandir}/man8/zone2sql.8*

%files backend-pipe
%defattr(-,root,root)
%{_libdir}/libpipebackend.so
%{_libdir}/libpipebackend.so.*

%files backend-mysql
%defattr(-,root,root)
%{_libdir}/libgmysqlbackend.so
%{_libdir}/libgmysqlbackend.so.*

%files backend-postgresql
%defattr(-,root,root)
%{_libdir}/libgpgsqlbackend.so
%{_libdir}/libgpgsqlbackend.so.*

%files backend-ldap
%defattr(-,root,root)
%{_libdir}/libldapbackend.so
%{_libdir}/libldapbackend.so.*

%files backend-opendbx
%defattr(-,root,root)
%{_libdir}/libopendbxbackend.so
%{_libdir}/libopendbxbackend.so.*

%files devel
%defattr(-,root,root)
%{_libdir}/*.la
%{_libdir}/*.a

%changelog
* Sun Aug 12 2007 Kees Monshouwer <mind|monshouwer_com> 2.9.21-2
- Fix ldap compile problem
- Changed opendbx dependencies
- Powerdns now builds on CentOS 5 

* Sat Apr 21 2007 Kees Monshouwer <mind|monshouwer_com> 2.9.21-1.MIND
- Update to 2.9.21
- Changed package name to pdns-server
- Removed pre 2.9.20 items from changelog

* Sat Jun 17 2006 Kees Monshouwer <mind|monshouwer_com> 2.9.20-4.MIND
- Applied opendbx backend patch (06172006)

* Tue Jun 13 2006 Kees Monshouwer <mind|monshouwer_com> 2.9.20-3.MIND
- Added opendbx backend

* Sun Jun 11 2006 Kees Monshouwer <mind|monshouwer_com> 2.9.20-2.MIND
- Removed the recursor pakage, this is now a separate, much more powerfull,
  project.
- Added postgresql backend
- Disabled geo backed 
- Added/changed some dependencies (Please let me know if something is worng or missing)

* Wed Mar 15 2006 Kees Monshouwer <mind|monshouwer_com> 2.9.20-1.MIND
- Update to version 2.9.20

* Mon Apr 11 2005 Kees Monshouwer <mind|monshouwer_com> 2.9.13-1.MIND
- Initial build for CentOS 4 
- Adopted large parts from the mandrake spec by Oden Eriksson
